Use Windows.pkg
Use DFClient.pkg
Use ExchangeConnector.pkg
Use cTextEdit.pkg
Use dfSpnFrm.pkg

Activate_View Activate_oXEtester for oXEtester
Object oXEtester is a dbView

    Set Border_Style to Border_Thick
    Set Size to 373 301
    Set Location to 7 8
    Set Label to "Exchange Email tester"
    Set pbAutoActivate to True
    Set piMinSize to 347 301

    Function Split String sText String sSeparator Returns String[]
        String sPart
        String[] Parts
        Integer iPartCount iSpacePos
        Integer iSeparatorLen
        Move (Length(sSeparator)) to iSeparatorLen
        // Repeat as long as sText contains data
        While (sText <> "") 
            // Find the first/next space
            Move (Pos (sSeparator, sText)) to iSpacePos
            If (iSpacePos > 0) Begin
                // Take the left part
                Move (Left (sText, iSpacePos - 1)) to sPart
                // Move the remainder to the text variable
                Move (Right (sText, Length (sText) - iSpacePos - (iSeparatorLen-1))) to sText
            End 
            // If no more spaces are found
            Else Begin
                // Make Part equal to the text
                Move sText to sPart
                // Empty text to stop the loop
                Move "" to sText
            End
            // In this email example we do not want blank rows
            If (sPart > '') Begin
                Move sPart to Parts[iPartCount]
                Increment iPartCount
            End
        Loop
        Function_Return Parts
    End_Function  // SplitStringIntoParts
    
    Function TextToArray String sValue Returns String[]
        String[] sLines
        Get Split sValue (Character(13) + Character(10)) to sLines
        Function_Return sLines
    End_Function 

    Object oExchangeConnector is a cExchangeConnector
    End_Object

    Object oRadioGroup1 is a RadioGroup
        Set Location to 7 7
        Set Size to 63 287
        Set Label to "Enter your credentials"
    
        Object oRdoCredentials is a Radio
            Set Size to 10 50
            Set Location to 11 10
            Set Label to "Enter credentials"
        End_Object
    
        Object oFrmEmailAddress is a Form
            Set Size to 13 174
            Set Location to 21 97
            Set Label to "Email Address:"
        End_Object

        Object oFrmPassword is a Form
            Set Size to 13 174
            Set Location to 38 97
            Set Label to "Password:"
        End_Object

        Object oRdoTrusted is a Radio
            Set Label to "Use domain trusted connection"
            Set Size to 10 139
            Set Location to 51 10
        End_Object
    
        Procedure Notify_Select_State Integer iToItem Integer iFromItem
            Forward Send Notify_Select_State iToItem iFromItem
            // for augmentation
        End_Procedure
    
        Set Current_Radio to 0

    End_Object

    Object oEndpointGroup is a Group
        Set Size to 35 287
        Set Location to 72 7
        Set Label to "Please enter or confirm the service endpoint or use auto discover (prompt button)"

        Object oFrmExchangeServiceEndPoint is a Form
            Set Size to 13 174
            Set Location to 16 96
            Set Label to "Exchange service endpoint:"
            Set Label_Col_Offset to 90
            Set Value to "https://outlook.office365.com/EWS/Exchange.asmx"
            Set Prompt_Button_Mode to PB_PromptOn
            
            Procedure Prompt
                String sEmailAddress sPassword
                String sExchangeServiceEndPoint
                Integer eResponse
                Get Value of oFrmEmailAddress to sEmailAddress
                Get Value of oFrmPassword to sPassword
                Set Value to ''
                If (sEmailAddress = '' or sPassword = '') Begin
                    Send Stop_Box 'Please provide your email address and password for the discovery service to use'
                End
                Else Begin
                    Get YesNo_Box "The discovery service takes about 20 seconds, you would normally do this once per email server, and store this value in your program.\nContinue?" "Email server endpoint discovert" MB_DEFBUTTON1 to eResponse
                    If (eResponse = MBR_Yes) Begin
                        Send Cursor_Wait of Cursor_Control
                        Get ExchangeServiceEndPoint of oExchangeConnector sEmailAddress sPassword to sExchangeServiceEndPoint
                        Send Cursor_Ready of Cursor_Control
                        If (sExchangeServiceEndPoint > '') Begin
                            Set Value of oFrmExchangeServiceEndPoint to sExchangeServiceEndPoint
                            Send Info_Box (SFormat("Your exchange service endpoint could be found and is '%1'.", sExchangeServiceEndPoint))
                        End
                        Else Begin
                            Send UserError "Your exchange service cannot be found\nPlease check your email address and password.\nAlternatively your exchange service could have autodiscover turned off" "Unable to find service"
                        End
                    End
                End
            End_Procedure
            
            On_Key kClear Send myDefault
            
            Procedure myDefault
                Set Value to "https://outlook.office365.com/EWS/Exchange.asmx"
            End_Procedure
            
        End_Object
    End_Object

    Object oTabDialog1 is a TabDialog
        Set Size to 262 287
        Set Location to 108 7

        Object oTabEmail is a TabPage
            Set Label to "Create && send email"
    
            Object oTextBox1 is a TextBox
                Set Size to 9 34
                Set Location to 16 26
                Set Label to 'Separate multiple recipients and attachments with a line separator "enter"'
            End_Object
    
            Object oFrmFrom is a Form
                Set Size to 13 183
                Set Location to 31 87
                Set Label to "From / Reply to:"
            End_Object
    
            Object oTxtRecipients is a cTextEdit
                Set Size to 19 183
                Set Location to 47 87
                Set Label to "Recipients: *"
                Set Label_Col_Offset to 60
                Set Label_Justification_Mode to JMode_Left
            End_Object
    
            Object oTxtRecipientsCC is a cTextEdit
                Set Size to 19 183
                Set Location to 69 87
                Set Label to "Recipients CC: *"
                Set Label_Col_Offset to 60
                Set Label_Justification_Mode to JMode_Left
            End_Object
    
            Object oTxtRecipientsBCC is a cTextEdit
                Set Size to 19 183
                Set Location to 91 87
                Set Label to "Recipients BCC: *"
                Set Label_Col_Offset to 60
                Set Label_Justification_Mode to JMode_Left
            End_Object
    
            Object oFrmSubject is a Form
                Set Size to 13 183
                Set Location to 114 87
                Set Label to "Subject:"
            End_Object
    
            Object oTxtBody is a cTextEdit
                Set Size to 43 183
                Set Location to 132 87
                Set Label to "Body (html):"
                Set Label_Col_Offset to 60
                Set Label_Justification_Mode to JMode_Left
            End_Object
    
            Object oTxtAttachments is a cTextEdit
                Set Size to 19 183
                Set Location to 179 87
                Set Label to "Attachments: *"
                Set Label_Col_Offset to 60
                Set Label_Justification_Mode to JMode_Left
            End_Object

            Object oTextBox2 is a TextBox
                Set Auto_Size_State to False
                Set Size to 22 119
                Set Location to 200 11
                Set Label to "* Separate the multiple values (e.g. recipients) with a CrLf (Enter)."
                Set Justification_Mode to JMode_Left
            End_Object

            Object oInlineImageHelpButton is a Button
                Set Size to 14 57
                Set Location to 146 26
                Set Label to "Inline Images"
                Set psImage to "ActionHelp.ico"
            
                // fires when the button is clicked
                Procedure OnClick
                    Send Info_Box ("Attachments of the type image can be embedded/inline in the email\n" + ;
                                   "These are shown in outlook and some other email readers and often used for logos.\n\n" + ;
                                   'Insert in the body the text <img width=100 height=100 src="cid:002">\n' + ;
                                   'the 002 in this example refers to the second attachment (array_item 1)') 'Inline attachment help' 
                End_Procedure
            
            End_Object

            Function ComposeEmail Returns tExchangeConnectorEmail
                tExchangeConnectorEmail Email
                String sValue sStatus
                Send Cursor_Wait of Cursor_Control
                Get Value of oFrmFrom to Email.replyTo
                Get TextToArray (Value(oTxtRecipients)) to Email.recipients
                Get TextToArray (Value(oTxtRecipientsCC)) to Email.recipientsCC
                Get TextToArray (Value(oTxtRecipientsBCC)) to Email.recipientsBCC
                Get Value of oFrmSubject to Email.subject
                Get Value of oTxtBody to Email.body
                Get TextToArray (Value(oTxtAttachments)) to Email.attachmentFiles
                
                Get Value of oFrmEmailAddress to Email.username
                Get Value of oFrmPassword to Email.password
                Get Value of oFrmExchangeServiceEndPoint to Email.serviceEndpoint
                Function_Return Email
            End_Function
    
            Object oBtnSend is a Button
                Set Size to 14 106
                Set Location to 199 163
                Set Label to "Send && save in Sent folder"
            
                // fires when the button is clicked
                Procedure OnClick
                    tExchangeConnectorEmail Email
                    String sValue sStatus
                    Send Cursor_Wait of Cursor_Control
                    Get Value of oFrmFrom to Email.replyTo
                    Get TextToArray (Value(oTxtRecipients)) to Email.recipients
                    Get TextToArray (Value(oTxtRecipientsCC)) to Email.recipientsCC
                    Get TextToArray (Value(oTxtRecipientsBCC)) to Email.recipientsBCC
                    Get Value of oFrmSubject to Email.subject
                    Get Value of oTxtBody to Email.body
                    Get TextToArray (Value(oTxtAttachments)) to Email.attachmentFiles
                    
                    Get Value of oFrmEmailAddress to Email.username
                    Get Value of oFrmPassword to Email.password
                    Get Value of oFrmExchangeServiceEndPoint to Email.serviceEndpoint
                    
                    Get SendEmail of oExchangeConnector (&Email) to sStatus
                    Send Cursor_Ready of Cursor_Control
                    If (sStatus = 'OK') Begin
                        Send Info_Box 'Sent'    
                    End
                    Else Begin
                        Send UserError sStatus "Email failed!"
                    End
        
                End_Procedure
            
            End_Object

            Object oBtnSendOnly is a Button
                Set Size to 14 106
                Set Location to 231 163
                Set Label to "Send only (no trace)"
            
                // fires when the button is clicked
                Procedure OnClick
                    tExchangeConnectorEmail Email
                    String sValue sStatus

                    Get ComposeEmail to Email
                    Send Cursor_Wait of Cursor_Control
                    Get SendEmailNoCopyToSent of oExchangeConnector (&Email) to sStatus
                    Send Cursor_Ready of Cursor_Control
                    If (sStatus = 'OK') Begin
                        Send Info_Box 'Sent - as requested no copy in Sent folder'    
                    End
                    Else Begin
                        Send UserError sStatus "Email failed!"
                    End
                End_Procedure
            
            End_Object

            Object oBtnSaveToDrafts is a Button
                Set Size to 14 106
                Set Location to 215 163
                Set Label to "Create and save in Drafts folder"
            
                // fires when the button is clicked
                Procedure OnClick
                    tExchangeConnectorEmail Email
                    String sValue sStatus

                    Get ComposeEmail to Email
                    Send Cursor_Wait of Cursor_Control
                    Get SaveEmailToDrafts of oExchangeConnector (&Email) to sStatus
                    Send Cursor_Ready of Cursor_Control
                    If (sStatus = 'OK') Begin
                        Send Info_Box 'Email created and saved into Drafts folder'    
                    End
                    Else Begin
                        Send UserError sStatus "Email failed!"
                    End
        
                End_Procedure
            
            End_Object
    
        End_Object

        Object oTabPage1 is a TabPage
            Set Label to 'Meeting Request'

            Object oTextBox1 is a TextBox
                Set Size to 9 34
                Set Location to 8 15
                Set Label to 'Separate multiple attendees and attachments with a line separator "enter"'
            End_Object

            Object oTxtRequired is a cTextEdit
                Set Size to 19 183
                Set Location to 24 80
                Set Label to "Required attendees:"
                Set Label_Col_Offset to 65
                Set Label_Justification_Mode to JMode_Left
            End_Object

            Object oTxtOptional is a cTextEdit
                Set Size to 19 183
                Set Location to 46 80
                Set Label to "Optional attendees:"
                Set Label_Col_Offset to 65
                Set Label_Justification_Mode to JMode_Left
            End_Object

            Object oFrmSubject is a Form
                Set Size to 13 183
                Set Location to 68 80
                Set Label to "Subject:"
                Set Label_Col_Offset to 65
            End_Object

            Object oFrmLocation is a Form
                Set Size to 13 183
                Set Location to 85 80
                Set Label to "Location:"
                Set Label_Col_Offset to 65
            End_Object

            Object oFrmStartDate is a Form
                Set Size to 13 53
                Set Location to 102 80
                Set Label to "Start time:"
                Set Form_Datatype to Mask_Date_Window
                Set Label_Col_Offset to 65

                Procedure OnExitObject
                    Forward Send OnExitObject
                    Date dDate
                    Get Value to dDate
                    Set Value of oFrmEndDate to dDate
                End_Procedure
            End_Object

            Object oSpnStartHour is a SpinForm
                Set Size to 13 29
                Set Location to 102 141
                Set Maximum_Position to 23
                Set Minimum_Position to 0
            End_Object

            Object oSpnStartMinute is a SpinForm
                Set Size to 13 29
                Set Location to 102 179
                Set Maximum_Position to 59
                Set Minimum_Position to 00
            End_Object

            Object oFrmEndDate is a Form
                Set Size to 13 53
                Set Location to 119 80
                Set Label to "End time:"
                Set Form_Datatype to Mask_Date_Window
                Set Label_Col_Offset to 65
            End_Object

            Object oSpnEndHour is a SpinForm
                Set Size to 13 29
                Set Location to 119 141
                Set Maximum_Position to 23
                Set Minimum_Position to 0
            End_Object

            Object oSpnEndMinute is a SpinForm
                Set Size to 13 29
                Set Location to 119 179
                Set Maximum_Position to 59
                Set Minimum_Position to 00
            End_Object

            Object oChkIsAllDay is a CheckBox
                Set Size to 10 50
                Set Location to 104 215
                Set Label to "All day event"
            
                Procedure OnChange
                    Boolean bChecked
                    Get Checked_State to bChecked
                    Set Enabled_State of oSpnStartHour   to (not(bChecked))
                    Set Enabled_State of oSpnStartMinute to (not(bChecked))
                    Set Enabled_State of oSpnEndHour     to (not(bChecked))
                    Set Enabled_State of oSpnEndMinute   to (not(bChecked))
                End_Procedure
            
            End_Object

            Object oTxtBody is a cTextEdit
                Set Size to 32 183
                Set Location to 137 81
                Set Label to "Body (html):"
                Set Label_Col_Offset to 65
                Set Label_Justification_Mode to JMode_Left
                Procedure Insert String sInsertText
                    Integer iPos
                    String sText
                    
                    Get SelStart to iPos
                    Send SetSel iPos -1
                    Get SelText to sText
                    Move (sInsertText + sText) to sText
                    Send ReplaceSel sText
                End_Procedure                
            End_Object

            Object oInlineImageHelpButton is a Button
                Set Size to 14 57
                Set Location to 153 14
                Set Label to "Inline Images"
                Set psImage to "ActionHelp.ico"
            
                // fires when the button is clicked
                Procedure OnClick
                    Integer eResponse
                    Get YesNo_Box ("Attachments of the type image can be embedded/inline in the email\n" + ;
                                   "These are shown in outlook and some other email readers and often used for logos.\n\n" + ;
                                   'Insert in the body the text <img width=100 height=100 src="cid:002">\n' + ;
                                   'the 002 in this example refers to the second attachment (array_item 1)\n' + ;
                                   '\nClick Yes to insert a reference to the first attachment at the current cursor position') 'Inline attachment help' MB_DEFBUTTON1 to eResponse
                    If (eResponse = MBR_Yes) Begin
                        Send Insert to oTxtBody '<img src="cid:001">'
                    End
                End_Procedure
            
            End_Object

            Object oTxtAttachments is a cTextEdit
                Set Size to 19 183
                Set Location to 173 81
                Set Label to "Attachments:"
                Set Label_Col_Offset to 65
                Set Label_Justification_Mode to JMode_Left
            End_Object

            Object oBtnSend is a Button
                Set Location to 196 214
                Set Label to "Send"
            
                // fires when the button is clicked
                Procedure OnClick
                    tExchangeConnectorMeeting Meeting
                    String sValue sStatus
                    Date dDate
                    Send Cursor_Wait of Cursor_Control
                    Get TextToArray (Value(oTxtRequired)) to Meeting.requiredAttendees
                    Get TextToArray (Value(oTxtOptional)) to Meeting.optionalAttendees
                    Get Value of oFrmSubject to Meeting.subject
                    Get Value of oFrmLocation to Meeting.location
                    Get Value of oFrmStartDate to dDate
                    Move (DateGetYear(dDate)) to Meeting.startYear
                    Move (DateGetMonth(dDate)) to Meeting.startMonth
                    Move (DateGetDay(dDate)) to Meeting.startDay
                    Get Value of oSpnStartHour to Meeting.startHour
                    Get Value of oSpnStartMinute to Meeting.startMinute
                    Get Value of oFrmEndDate to dDate
                    Move (DateGetYear(dDate)) to Meeting.endYear
                    Move (DateGetMonth(dDate)) to Meeting.endMonth
                    Move (DateGetDay(dDate)) to Meeting.endDay
                    Get Value of oSpnEndHour to Meeting.endHour
                    Get Value of oSpnEndMinute to Meeting.endMinute
                    Get Checked_State of oChkIsAllDay to Meeting.isAllDayEvent
                    Get Value of oTxtBody to Meeting.body
                    Get TextToArray (Value(oTxtAttachments)) to Meeting.attachmentFiles
                    
                    Get Value of oFrmEmailAddress to Meeting.username
                    Get Value of oFrmPassword to Meeting.password
                    Get Value of oFrmExchangeServiceEndPoint to Meeting.serviceEndpoint
                    
                    Get CreateMeetingRequest of oExchangeConnector (&Meeting) to sStatus
                    Send Cursor_Ready of Cursor_Control
                    If (sStatus = 'OK') Begin
                        Send Info_Box 'Sent'    
                    End
                    Else Begin
                        Send UserError sStatus "Meeting request failed!"
                    End
        
                End_Procedure
            
            End_Object
        End_Object
    End_Object

End_Object
